import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import java.util.*;

public class MillionaerGUI extends JFrame implements ActionListener {

  private JTextArea eingabe;
  private int nr;
  private int gewinn;
  private MillionaerDatenbank db;
  
  public MillionaerGUI() {
  
    db = new MillionaerDatenbank();    
    nr = 0;
    gewinn = 0;
      
    /* a) Allgemeine Vorbereitungen */
    /* ---------------------------- */
    
    /* In JFrame wird zwischen dem Fenster und der Zeichenflaeche
     * unterschieden. cpane repraesentiert die Zeichenfl?che. */
    Container cpane = getContentPane(); 
    
    /* verwendet KEINEN LayoutManager, d.h. alle Bestandteile des
       Fenster werden absolut positioniert und wachsen bei ?nderung
       der Fenstergroesse NICHT mit. */
    cpane.setLayout(null);
    
    /* Titel, erscheint am oberen Rand des Fensters. */
    setTitle("Wer wird Millionaer?");
    
    /* Position des Fensters (200,200) und Groesse (800x530) */
    setBounds(200,200,800,530);
    
    /* Verhalten beim Schliessen des Fensters - Programmende! */
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    
    
    /* b) Einf?gen der linken Haelfte */
    /* ----------------------------- */
    
    /* Erzeugen einer Textbox */
    eingabe = new JTextArea();
    eingabe.setBounds(50,30,700,300);
    
    /* Scrollbox um die Textbox */
    JScrollPane eingabescrollbox = new JScrollPane(eingabe);
    eingabescrollbox.setBounds(50,30,700,300);

    /* Einfuegen der Textbox in die Zeichenflaeche */
    cpane.add(eingabescrollbox);
    
    
    /* Erzeugen eines Buttons */
    JButton bubble_button = new JButton("1");
    bubble_button.setBounds(325,345,150,25);
    
    /* Kommando, das beim Druecken uebermittelt wird */
    bubble_button.setActionCommand("1");
    
    /* Setzt das aktuelle Fenster als Listener (d.h. das Fenster
     * wird benachrichtigt, wenn der Button gedrueckt wird. */
    bubble_button.addActionListener(this);

    /* Einfuegen des Buttons in die Zeichenflaeche */
    cpane.add(bubble_button);

  
    /* Erzeugen eines Buttons */
    JButton betterbubble_button = new JButton("2");
    betterbubble_button.setBounds(325,380,150,25);
    
    /* Kommando, das beim Druecken uebermittelt wird */
    betterbubble_button.setActionCommand("2");
    
    /* Setzt das aktuelle Fenster als Listener (d.h. das Fenster
     * wird benachrichtigt, wenn der Button gedrueckt wird. */
    betterbubble_button.addActionListener(this);

    /* Einfuegen des Buttons in die Zeichenflaeche */
    cpane.add(betterbubble_button);

    
    /* Erzeugen eines Buttons */
    JButton straightselection_button = new JButton("3");
    straightselection_button.setBounds(325,415,150,25);
    
    /* Kommando, das beim Druecken uebermittelt wird */
    straightselection_button.setActionCommand("3");
    
    /* Setzt das aktuelle Fenster als Listener (d.h. das Fenster
     * wird benachrichtigt, wenn der Button gedrueckt wird. */
    straightselection_button.addActionListener(this);

    /* Einfuegen des Buttons in die Zeichenflaeche */
    cpane.add(straightselection_button);
    
    
    /* Erzeugen eines Buttons */
    JButton straightinsertion_button = new JButton("4");
    straightinsertion_button.setBounds(325,450,150,25);
    
    /* Kommando, das beim Druecken uebermittelt wird */
    straightinsertion_button.setActionCommand("4");
    
    /* Setzt das aktuelle Fenster als Listener (d.h. das Fenster
     * wird benachrichtigt, wenn der Button gedrueckt wird. */
    straightinsertion_button.addActionListener(this);

    /* Einfuegen des Buttons in die Zeichenflaeche */
    cpane.add(straightinsertion_button);

    naechsteFrage();
  }


  private void naechsteFrage() {
      db.bestimmeNaechsteFrage();

      eingabe.setText("");
      
      nr++;
      if (nr==16) {
          JOptionPane.showMessageDialog(this,"Hurrah, du bist Millionaer!");
          System.exit(0);
      }
      
      eingabe.append("Frage Nr. "+nr+" - Wert:"+db.gibWert()+"€\n\n");      
      eingabe.append(db.gibFrage()+"\n\n");
      String[] antworten= db.gibAntworten();
      
      for (int i=0; i<4; i++) {
          eingabe.append((i+1)+": "+antworten[i]+"\n");
      }
  }
  
  
  /** Eine Aktion wurde ausgel?st. Fenster reagiert entsprechend. */
  public void actionPerformed(ActionEvent event) {
    
    if (event.getActionCommand().equals("1")) {     
        if (db.gibLoesung()==1) {
            gewinn = db.gibWert();
            naechsteFrage();
        }
        else {
            JOptionPane.showMessageDialog(this,"Leider falsch (Richtig ist Nr. "+db.gibLoesung()+")!\nGewinn: "+gewinn);
            System.exit(0);
        }
    }
    else if (event.getActionCommand().equals("2")) {     
        if (db.gibLoesung()==2) {
            gewinn = db.gibWert();
            naechsteFrage();
        }
        else {
            JOptionPane.showMessageDialog(this,"Leider falsch (Richtig ist Nr. "+db.gibLoesung()+")!\nGewinn: "+gewinn);
            System.exit(0);
        }
    }
    else if (event.getActionCommand().equals("3")) {     
        if (db.gibLoesung()==3) {
            gewinn = db.gibWert();
            naechsteFrage();
        }
        else {
            JOptionPane.showMessageDialog(this,"Leider falsch (Richtig ist Nr. "+db.gibLoesung()+")!\nGewinn: "+gewinn);
            System.exit(0);
        }
    }
    else if (event.getActionCommand().equals("4")) {     
        if (db.gibLoesung()==4) {
            gewinn = db.gibWert();
            naechsteFrage();
        }
        else {
            JOptionPane.showMessageDialog(this,"Leider falsch (Richtig ist Nr. "+db.gibLoesung()+")!\nGewinn: "+gewinn);
            System.exit(0);
        }
    }
  }


  /** Das Fenster kann direkt gestartet werden, da es die main-Methode
   *  implementiert. */
  public static void main(String[] args) {
    
    MillionaerGUI fenster = new MillionaerGUI();
    fenster.setVisible(true);
    
  }

}
